package jnv.netproc;

import java.util.*;
//import java.util.Collection;
//import java.util.Iterator;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

import jnv.hostlist.*;
import java.io.*;
import java.net.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Killer{R}
 * @version 1.0
 */

public class NVSyncer extends Observable{// implements java.io.Serializable {

private Observer syncobserver=null;
class SyncTask extends java.util.TimerTask
 {
 private NVSyncer syncer;
 public SyncTask(NVSyncer par)
 {
 syncer=par;
 }
 public void run()
 {
 syncer.GoSync();
 }
 }
  private NVHostList hostlist;
  private String ServerHost="127.0.0.1";
  private int ServerPort=1215;
  private String ServerLogin="Anonymous";
  private String ServerPassword="";
  private boolean AutoSyncEnabled=false;
  private int AutoSyncPeriod=600;
  private Socket sock;
  private StringBuffer recvbuf=new StringBuffer();
  private java.util.Timer timer=null;
  private String WhatToSync[]=new String[0];
  public boolean SyncActive=false;

  public void SetSyncObserver(Observer obs){
  syncobserver=obs;
  }

  public void setServerHost(String val)
  {
  ServerHost=val;
  }
  public void setServerPort(int val)
  {
  ServerPort=val;
  }
  public void setServerLogin(String val)
  {
  ServerLogin=val;
  }
  public void setServerPassword(String val)
  {
  ServerPassword=val;
  }
  public void setAutoSyncEnabled(boolean val)
  {
  AutoSyncEnabled=val;
  ResetTimer();
  }
  public void setAutoSyncPeriod(int val)
  {
  AutoSyncPeriod=val;
  ResetTimer();
  }
  public void setWhatToSync(String []val)
  {
  WhatToSync=val;
  }

  public String getServerHost()
  {
  return ServerHost;
  }
  public int getServerPort()
  {
  return ServerPort;
  }
  public String getServerLogin()
  {
  return ServerLogin;
  }
  public String getServerPassword()
  {
  return ServerPassword;
  }
  public boolean getAutoSyncEnabled()
  {
  return AutoSyncEnabled;
  }
  public int getAutoSyncPeriod()
  {
  return AutoSyncPeriod;
  }
  private void ResetTimer()
  {
  if(timer!=null)timer.cancel();
  if(AutoSyncEnabled)
   {
   timer=new java.util.Timer();
   timer.scheduleAtFixedRate(new SyncTask(this),AutoSyncPeriod*1000,AutoSyncPeriod*1000);
   }else timer=null;
  }

  public void GoSync()
  {
  if(!SyncActive)
  {
  SyncActive=true;
  try {
   sock=new Socket(ServerHost,ServerPort);
   InputStream is=sock.getInputStream();
   OutputStream os=sock.getOutputStream();
   os.write((NVNvhProc.nvh_esc_format(ServerLogin)+"#"+NVNvhProc.nvh_esc_format(ServerPassword)+"\r\n").getBytes());
   os.write("hostenum#".getBytes());
   for(int i=0;i<WhatToSync.length;i++)os.write((NVNvhProc.nvh_esc_format(WhatToSync[i])+"#").getBytes());
   os.write("$\r\n".getBytes());

   recvbuf.setLength(0);
   char Buf[]=new char[0xffff];
   InputStreamReader rd=new InputStreamReader(is);
   for(;;)
    {
    int len=rd.read(Buf);
    if(len<0)break;
    int rl=recvbuf.length();
    recvbuf.setLength(rl+len);
    for(int i=0;i<len;i++)recvbuf.setCharAt(rl+i,Buf[i]);
    if(ProcessRecvData()!=0)break;
    }

   sock.close();
   }catch(Exception e) {
   e.printStackTrace();
   }
  if(syncobserver!=null)syncobserver.update((Observable)this,null);
  SyncActive=false;
  }
  }

  public NVSyncer(NVHostList hostlist) {
  this.hostlist=hostlist;
  }

  private int ProcessRecvData() {
  int ret=0;
  boolean con=true;
  while(con)
   {
   con=false;
   for(int i=0;i<recvbuf.length();i++)
   if(recvbuf.charAt(i)=='\r')
    {
    String ln=recvbuf.substring(0,i);
    ProcessLine(ln);
    i++;
    while((i<recvbuf.length())&&((recvbuf.charAt(i)=='\r')||(recvbuf.charAt(i)=='\n')))i++;
    if(i<recvbuf.length())con=true;
    recvbuf.delete(0,i);
    ret++;
    break;
    }
   }
  return ret;
  }

  private void ProcessLine(String ln)
   {
   for(int i=0;i<ln.length();i++)
   if(ln.charAt(i)=='#')
    {
    String cmd=ln.substring(0,i);
    String par=ln.substring(i+1,ln.length());
    if(cmd.compareTo("hostenum")==0)ProcessHostEnum(par);
    }
   }
  private void ProcessHostEnum(String par)
   {
   int j=0;
   for(int i=0;i<par.length();i++)
   if(par.charAt(i)=='$')
    {
      ProcessHostRecord(par.substring(j,i));
      j=i+1;
    }
   }
  private void ProcessHostRecord(String rec)
   {
   int j=0,p=0;
   String hostname="",ip="";
   NVHost h=null;
   for(int i=0;i<rec.length();i++)
   if(rec.charAt(i)=='#')
    {
      String s=rec.substring(j,i);
      switch(p)
       {
       case 0:hostname=NVNvhProc.nvh_esc_unformat(s);break;
       case 1:ip=NVNvhProc.nvh_esc_unformat(s);h=hostlist.putHost(hostname,ip);break;
       default:
        {
        int x=s.indexOf('=');
        if(x!=0)
         {
         String varname=NVNvhProc.nvh_esc_unformat(s.substring(0,x));
         String vardata=NVNvhProc.nvh_esc_unformat(s.substring(x+1,s.length()));
         h.setMetaVar(varname,vardata);
         }
        }
       }
      j=i+1;p++;
    }
   }
}