package jnv;

import java.awt.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class FiltersDialog extends JDialog {
  private JPanel panel1 = new JPanel();
  private JCheckBox jCheckBox1 = new JCheckBox();
  private JCheckBox jCheckBox2 = new JCheckBox();
  private JCheckBox jCheckBox3 = new JCheckBox();
  private VerticalFlowLayout verticalFlowLayout1 = new VerticalFlowLayout();
  private JPanel jPanel1 = new JPanel();
  private XYLayout xYLayout1 = new XYLayout();
  private JCheckBox jCheckBox4 = new JCheckBox();
  private JTextField jTextField1 = new JTextField();
  private JCheckBox jCheckBox5 = new JCheckBox();
  private JTextField jTextField2 = new JTextField();
  private JButton jButton1 = new JButton();
  private JButton jButton2 = new JButton();
  private JCheckBox jCheckBox6 = new JCheckBox();
  private JCheckBox jCheckBox7 = new JCheckBox();

  public FiltersDialog(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try {
      jbInit();
      pack();
      Rectangle mybounds=getBounds();
      Dimension scrsz=Toolkit.getDefaultToolkit().getScreenSize();
      mybounds.x=(scrsz.width-mybounds.width)/2;
      mybounds.y=(scrsz.height-mybounds.height)/2;
      setBounds(mybounds);
      validate();
      }
    catch(Exception ex) {
      ex.printStackTrace();
    }
  }

  public FiltersDialog() {
    this(null, "", false);
  }
  private void jbInit() throws Exception {
    panel1.setLayout(verticalFlowLayout1);
    jCheckBox1.setText("Show offline hosts");
    jCheckBox2.setText("Show NETBIOS servers");
    jCheckBox3.setText("Show FTP servers");
    jPanel1.setPreferredSize(new Dimension(390, 100));
    jPanel1.setLayout(xYLayout1);
    jCheckBox4.setText("Show only hosts of sublist:");
    jTextField1.setText("Default");
    jCheckBox5.setText("Tree resources name filter:");
    jTextField2.setText("game");
    jButton1.setActionCommand("Ok");
    jButton1.setText("Ok");
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton1_actionPerformed(e);
      }
    });
    jButton2.setText("Cancel");
    jButton2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jButton2_actionPerformed(e);
      }
    });
    panel1.setPreferredSize(new Dimension(440, 290));
    this.setResizable(false);
    this.setTitle("Display filters");
    jCheckBox6.setActionCommand("");
    jCheckBox6.setText("Show hidden resources");
    jCheckBox7.setText("Show HTTP servers");
    getContentPane().add(panel1);
    panel1.add(jCheckBox1, null);
    panel1.add(jCheckBox2, null);
    panel1.add(jCheckBox3, null);
    panel1.add(jCheckBox7, null);
    panel1.add(jCheckBox6, null);
    panel1.add(jPanel1, null);
    jPanel1.add(jCheckBox4,   new XYConstraints(6, 8, -1, -1));
    jPanel1.add(jTextField1,      new XYConstraints(195, 8, 180, -1));
    jPanel1.add(jTextField2,      new XYConstraints(195, 35, 180, -1));
    jPanel1.add(jCheckBox5, new XYConstraints(6, 33, -1, -1));
    jPanel1.add(jButton1,   new XYConstraints(92, 69, -1, -1));
    jPanel1.add(jButton2, new XYConstraints(173, 69, -1, -1));
  }

  void jButton1_actionPerformed(ActionEvent e) {
  ((MainFrame)getParent()).UpdateFiltersFromDialog(this);
  hide();
  dispose();
  }

  void jButton2_actionPerformed(ActionEvent e) {
  hide();
  dispose();
  }



  void setShowOffline(boolean val){
  jCheckBox1.setSelected(val);
  }
  void setEnableNetbios(boolean val){
  jCheckBox2.setSelected(val);
  }
  void setEnableFtp(boolean val){
  jCheckBox3.setSelected(val);
  }
  void setEnableHttp(boolean val){
  jCheckBox7.setSelected(val);
  }
  void setShowHiddenRes(boolean val){
  jCheckBox6.setSelected(val);
  }

  void setEnableFltSubList(boolean val){
  jCheckBox4.setSelected(val);
  }
  void setEnableFltResTree(boolean val){
  jCheckBox5.setSelected(val);
  }
  void setFltSubList(String val){
  jTextField1.setText(val);
  }
  void setFltResTree(String val){
  jTextField2.setText(val);
  }

  boolean getShowOffline(){
  return jCheckBox1.isSelected();
  }
  boolean getEnableNetbios(){
  return jCheckBox2.isSelected();
  }
  boolean getEnableFtp(){
  return jCheckBox3.isSelected();
  }
  boolean getEnableHttp(){
  return jCheckBox7.isSelected();
  }
  boolean getShowHiddenRes(){
  return jCheckBox6.isSelected();
  }

  boolean getEnableFltSubList(){
  return jCheckBox4.isSelected();
  }
  boolean getEnableFltResTree(){
  return jCheckBox5.isSelected();
  }
  String getFltSubList(){
  return jTextField1.getText();
  }
  String getFltResTree(){
  return jTextField2.getText();
  }



}

