package jnv;

import jnv.hostlist.*;
import jnv.netproc.*;
import jnv.TableSort.*;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.tree.*;
import com.borland.jbcl.layout.*;
import javax.swing.event.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author Killer{R}
 * @version 1.0
 */

class FiltersSettings {
static public boolean showoff;
static public boolean shownb;
static public boolean showftp;
static public boolean showhttp;
static public boolean showhiddenres;
static public boolean enfltsublist;
static public boolean enfltrestree;
static public String fltsublist;
static public String fltrestree;
static void LoadSetup() {
  Properties props=new Properties();
  try
  {
  Runtime r=Runtime.getRuntime();
  FileInputStream s=new FileInputStream("jNV-client.flt");
  props.load(s);
  s.close();
  }catch(IOException ex){;}
  showoff=props.getProperty("showoff","True").compareTo("True")==0;
  shownb=props.getProperty("shownb","True").compareTo("True")==0;
  showftp=props.getProperty("showftp","True").compareTo("True")==0;
  showhttp=props.getProperty("showhttp","True").compareTo("True")==0;
  enfltsublist=props.getProperty("enfltsublist","False").compareTo("True")==0;
  enfltrestree=props.getProperty("enfltrestree","False").compareTo("True")==0;
  showhiddenres=props.getProperty("showhiddenres","False").compareTo("True")==0;
  fltsublist=props.getProperty("fltsublist","MyNetwork");
  fltrestree=props.getProperty("fltrestree","game");
  }


static void SaveSetup() {

  Properties props=new Properties();
  try
  {
  Runtime r=Runtime.getRuntime();
  props.setProperty("showoff",showoff?"True":"False");
  props.setProperty("shownb",shownb?"True":"False");
  props.setProperty("showftp",showftp?"True":"False");
  props.setProperty("showhttp",showhttp?"True":"False");
  props.setProperty("enfltsublist",enfltsublist?"True":"False");
  props.setProperty("enfltrestree",enfltrestree?"True":"False");
  props.setProperty("showhiddenres",showhiddenres?"True":"False");
  props.setProperty("fltsublist",fltsublist);
  props.setProperty("fltrestree",fltrestree);

  //props.setProperty("WindowX",this.getpo)
  FileOutputStream s=new FileOutputStream("jNV-client.flt");
  props.store(s,"jNetView by Killer{R}");
  s.close();
  }catch(IOException ex){;}
}

static boolean canShowHost(NVHost h) {
if((!showoff)&&(h.getMetaVar("ison").compareTo("off")==0))return false;
if(enfltsublist){
String map=h.getMetaVar("map");
if((map.length()!=0)&&(map.compareToIgnoreCase(fltsublist)!=0))return false;
}

int flags;
try
 {
 flags=Integer.parseInt(h.getMetaVar("flags"));
 }catch(NumberFormatException ex){flags=7;};
if(shownb&&((flags&0x200)==0))return true;
if(showftp&&((flags&0x1400)!=0))return true;
if(showhttp&&(h.getMetaVar("!httitle").length()!=0))return true;
return false;
}

static boolean canShowResource(String Resource) {
if((!showhiddenres)&&(Resource.length()!=0)&&(Resource.charAt(Resource.length()-1)=='$'))return false;
return ((!enfltrestree)||(Resource.toLowerCase().indexOf(fltrestree.toLowerCase())!=-1));
}

}


public class MainFrame extends JFrame {
  public class SyncObserver implements Observer {
  private MainFrame frame;
  public SyncObserver(MainFrame frame){
  this.frame=frame;
  }
  public void update(Observable o, Object arg){
  frame.RefreshViews();
  try{
  NVNvhProc.SaveHostList(hostlist,"default.nvh");
  }catch(IOException ex){
  }

  }
  }

  private DefaultTableModel model = new DefaultTableModel();
  private TableSorter sortmodel = new TableSorter(model);

  private DefaultTreeModel treemodel = new DefaultTreeModel(new DefaultMutableTreeNode());
  private DefaultTreeCellRenderer cellrenderer = new DefaultTreeCellRenderer();
  private DefaultTreeSelectionModel treeselmodel = new DefaultTreeSelectionModel();
  private StringBuffer recvbuf=new StringBuffer();
  private Socket sock;
  private boolean IsRefreshing=false;
  private String varnames[]=new String[16];
  private String colnames[]=new String[16];
  private String syncable[]=new String[16];
  private TitledBorder titledBorder1;
  private JMenuBar jMenuBar1 = new JMenuBar();
  private JMenu jMenu1 = new JMenu();
  private JMenuItem jMenuItem3 = new JMenuItem();
  private JMenu jMenu2 = new JMenu();
  private JMenuItem jMenuItem4 = new JMenuItem();
  private JMenu jMenu3 = new JMenu();
  private JMenuItem jMenuItem5 = new JMenuItem();
  private JMenu jMenu4 = new JMenu();
  private JMenuItem jMenuItem6 = new JMenuItem();
  private NVHostList hostlist=new NVHostList();
  private NVSyncer syncer=new NVSyncer(hostlist);
  private NVOpener opener=new NVOpener(hostlist);
  private JPopupMenu jPopupMenu1 = new JPopupMenu();
  private JMenuItem jMenuItem9 = new JMenuItem();
  private JMenuItem jMenuItem8 = new JMenuItem();
  private JTabbedPane jTabbedPane1 = new JTabbedPane();
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private JTable jTable1 = new JTable(sortmodel);
  private JTree jTree1 = new JTree(treemodel);
  private PaneLayout paneLayout1 = new PaneLayout();
  private PaneLayout paneLayout2 = new PaneLayout();
  private PaneLayout paneLayout3 = new PaneLayout();
  private JScrollPane jScrollPane1 = new JScrollPane(jTable1);
  private JScrollPane jScrollPane2 = new JScrollPane(jTree1);
  private JPopupMenu jPopupMenu2 = new JPopupMenu();
  private JMenuItem jMenuItem7 = new JMenuItem();
  private JMenuItem jMenuItem12 = new JMenuItem();
  private JMenuItem jMenuItem13 = new JMenuItem();

  private String TreeDisplayFilter = "";
  private JMenuItem jMenuItem11 = new JMenuItem();
  private int CurSortColumn = 0;
  private boolean CurSortInverse = false;
  public MainFrame() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void Go()
  {
  LoadSetup();
  show();
  setTitle("jNetView client");
  syncer.SetSyncObserver(new SyncObserver(this));
  try{
  NVNvhProc.LoadHostList(hostlist,"default.nvh");
  RefreshViews();
  }catch(IOException ex){
  }
  syncer.GoSync();
  addWindowListener(new WindowAdapter()
   {
   public void windowClosing(WindowEvent e) {
   SaveSetup();
   }
   });
  }

  public static void main(String[] args) {
    MainFrame mainFrame = new MainFrame();
    mainFrame.Go();

  }
  private void jbInit() throws Exception {
    titledBorder1 = new TitledBorder("");
    this.setDefaultCloseOperation(EXIT_ON_CLOSE);
    this.setJMenuBar(jMenuBar1);
    this.getContentPane().setLayout(paneLayout3);
    jMenu1.setText("File");
    jMenuItem3.setText("Exit");
    jMenuItem3.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem3_actionPerformed(e);
      }
    });
    jMenu2.setText("Settings");
    jMenu3.setText("Action");
    jMenuItem5.setActionCommand("Synchronize now");
    jMenuItem5.setText("Synchronize now");
    jMenuItem5.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem5_actionPerformed(e);
      }
    });
    jMenu4.setText("Help");
    jMenuItem6.setText("About");
    jMenuItem6.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem6_actionPerformed(e);
      }
    });
    jMenuItem4.setText("Preferences");
    jMenuItem4.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem4_actionPerformed(e);
      }
    });

    //jTable1.setBorder(BorderFactory.createLoweredBevelBorder());

    jMenuItem9.setText("Save to .nvh");
    jMenuItem9.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem9_actionPerformed(e);
      }
    });
    jMenuItem8.setText("Add from .nvh");
    jMenuItem8.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem8_actionPerformed(e);
      }
    });
    model.addTableModelListener(new javax.swing.event.TableModelListener() {
      public void tableChanged(TableModelEvent e) {
        model_tableChanged(e);
      }
    });
    jTable1.setToolTipText("");
    jTable1.setActionMap(null);
    jTable1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTable1_mouseClicked(e);
      }
    });

    jTree1.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        jTree1_mouseClicked(e);
      }
    });
    addMouseListenerToHeaderInTable();

    jScrollPane1.setAutoscrolls(true);
    jScrollPane2.setAutoscrolls(true);
    jScrollPane2.setBorder(BorderFactory.createLoweredBevelBorder());
    jPanel1.setLayout(paneLayout1);
    jPanel2.setLayout(paneLayout2);
    jTree1.setToolTipText("");
    jTree1.setCellRenderer(cellrenderer);
    jTree1.setRootVisible(false);
    jTree1.setSelectionModel(treeselmodel);
    jMenuItem7.setActionCommand("Open resource");
    jMenuItem7.setText("Open resource");
    jMenuItem7.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem7_actionPerformed(e);
      }
    });
    jMenuItem12.setText("Expand whole tree");
    jMenuItem12.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem12_actionPerformed(e);
      }
    });
    jMenuItem13.setText("Collapse whole tree");
    jMenuItem13.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem13_actionPerformed(e);
      }
    });
    jMenuItem11.setText("Display filters");
    jMenuItem11.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuItem11_actionPerformed(e);
      }
    });
    jPanel1.setMinimumSize(new Dimension(43, 324));
    jPanel1.setPreferredSize(new Dimension(43, 324));
    jMenuBar1.add(jMenu1);
    jMenuBar1.add(jMenu3);
    jMenuBar1.add(jMenu2);
    jMenuBar1.add(jMenu4);
    jMenu1.add(jMenuItem8);
    jMenu1.add(jMenuItem9);
    jMenu1.addSeparator();
    jMenu1.add(jMenuItem3);
    jMenu2.add(jMenuItem11);
    jMenu2.add(jMenuItem4);
    jMenu3.add(jMenuItem5);
    jMenu4.add(jMenuItem6);
    this.getContentPane().add(jTabbedPane1,  new PaneConstraints("jTabbedPane1", "jTabbedPane1", PaneConstraints.ROOT, 1.0f));
    jTabbedPane1.add(jPanel1,    "Table view");
    jPanel1.add(jScrollPane1,  new PaneConstraints("jScrollPane1", "jScrollPane1", PaneConstraints.ROOT, 1.0f));
    jScrollPane1.setViewportView(jTable1);

    jTabbedPane1.add(jPanel2,   "Resources tree");
    //jPanel2.add(jTree1,  new PaneConstraints("jTree1", "jTree1", PaneConstraints.ROOT, 1.0f));
    jPanel2.add(jScrollPane2,  new PaneConstraints("jScrollPane2", "jScrollPane2", PaneConstraints.ROOT, 1.0f));
    jPopupMenu2.add(jMenuItem7);
    jPopupMenu2.addSeparator();
    jPopupMenu2.add(jMenuItem12);
    jPopupMenu2.add(jMenuItem13);
    jScrollPane2.setViewportView(jTree1);

  }




  void jMenuItem5_actionPerformed(ActionEvent e) {
  syncer.GoSync();
  }

  void jMenuItem3_actionPerformed(ActionEvent e) {
  System.exit(0);
  }

  void jMenuItem4_actionPerformed(ActionEvent e) {
  SetupDialog setupdialog= new SetupDialog(this,"Settings",true);
  setupdialog.setServerHost(syncer.getServerHost());
  setupdialog.setServerPort(syncer.getServerPort());
  setupdialog.setServerLogin(syncer.getServerLogin());
  setupdialog.setServerPassword(syncer.getServerPassword());
  setupdialog.setAutoSyncEnabled(syncer.getAutoSyncEnabled());
  setupdialog.setAutoSyncPeriod(syncer.getAutoSyncPeriod());
  for(int i=0;i<16;i++)
   {
   setupdialog.setOpenCmdMenu(i,opener.getOpenCmdMenu(i));
   setupdialog.setOpenCmdCommand(i,opener.getOpenCmdCommand(i));
   setupdialog.setVarName(i,varnames[i]);
   setupdialog.setSynMode(i,syncable[i]);
   setupdialog.setColName(i,colnames[i]);
   }
  setupdialog.setNbResOpenCmd(opener.getNbResOpenCmd());
  setupdialog.setFtpResOpenCmd(opener.getFtpResOpenCmd());
  setupdialog.setHttpResOpenCmd(opener.getHttpResOpenCmd());
  setupdialog.show();
  }
 private void ApplySyncerSynList()
 {
 int k=0;
 for(int i=0;i<16;i++)if(syncable[i].compareToIgnoreCase("Yes")==0)k++;
 String cursyns[]=new String[k];
 k=0;
 for(int i=0;i<16;i++)if(syncable[i].compareToIgnoreCase("Yes")==0)cursyns[k++]=varnames[i];
 syncer.setWhatToSync(cursyns);
 }
 public void UpdateSetupFromDialog(SetupDialog setupdialog)
 {
  syncer.setServerHost(setupdialog.getServerHost());
  syncer.setServerPort(setupdialog.getServerPort());
  syncer.setServerLogin(setupdialog.getServerLogin());
  syncer.setServerPassword(setupdialog.getServerPassword());
  syncer.setAutoSyncEnabled(setupdialog.getAutoSyncEnabled());
  syncer.setAutoSyncPeriod(setupdialog.getAutoSyncPeriod());

  for(int i=0;i<16;i++)
   {
   opener.setOpenCmdMenu(i,setupdialog.getOpenCmdMenu(i));
   opener.setOpenCmdCommand(i,setupdialog.getOpenCmdCommand(i));
   varnames[i]=setupdialog.getVarName(i);
   syncable[i]=setupdialog.getSynMode(i);
   colnames[i]=setupdialog.getColName(i);
   }
  opener.setNbResOpenCmd(setupdialog.getNbResOpenCmd());
  opener.setFtpResOpenCmd(setupdialog.getFtpResOpenCmd());
  opener.setHttpResOpenCmd(setupdialog.getHttpResOpenCmd());

  ApplySyncerSynList();
  SaveSetup();
  RefreshViews();
 }

 class MenuCommandActionListener implements ActionListener{
 private int CommandIndex;
 public MenuCommandActionListener(int CommandIndex){
 this.CommandIndex=CommandIndex;
 }
 public void actionPerformed(ActionEvent e){
 OpenCellsAs(CommandIndex);
 }
 }

  void ShowPopupMenuCommands(int x, int y){
  jPopupMenu1.removeAll();
  for(int i=0;i<16;i++)
   {
   String menu=opener.getOpenCmdMenu(i);
   String cmd=opener.getOpenCmdCommand(i);
   if((menu.length()!=0)||(cmd.length()!=0)){
   JMenuItem cmdmenu = new JMenuItem();
   cmdmenu.setText(menu);
   cmdmenu.addActionListener(new MenuCommandActionListener(i));
   jPopupMenu1.add(cmdmenu);
   }
   }
  jPopupMenu1.show(jTable1,x,y);
  }

  void jTable1_mouseClicked(MouseEvent e) {
  if((e.getModifiers()&e.BUTTON3_MASK)!=0)ShowPopupMenuCommands(e.getX(),e.getY());
  }

  void jTree1_mouseClicked(MouseEvent e) {
  if((e.getModifiers()&e.BUTTON3_MASK)!=0)jPopupMenu2.show(jTree1,e.getX(),e.getY());else
  if((e.getModifiers()&e.BUTTON1_MASK)!=0)
   {
   if(e.getClickCount()==2)OpenTreeSelectedResource(true);
   }



  }

  void OpenCellsAs(int Mode)
  {
  int []Rows=jTable1.getSelectedRows();
  for(int i=0;i<Rows.length;i++)
   {
   NVHost h=hostlist.getHostByName((String)sortmodel.getValueAt(Rows[i],0));
   if(h!=null)opener.OpenHost(h,Mode);
   }
  }

  void LoadSetup()
  {
  FiltersSettings.LoadSetup();

  Properties props=new Properties();
  try
  {
  Runtime r=Runtime.getRuntime();
  FileInputStream s=new FileInputStream("jNV-client.set");
  props.load(s);
  s.close();
  }catch(IOException ex){;}
  syncer.setServerHost(props.getProperty("Server.Host","127.0.0.1"));
  syncer.setServerPort(Integer.parseInt(props.getProperty("Server.Port","1215")));
  syncer.setServerLogin(props.getProperty("Server.Login","Anonymous"));
  syncer.setServerPassword(props.getProperty("Server.Password",""));
  syncer.setAutoSyncEnabled(props.getProperty("AutoSync.Enabled","True").compareTo("True")==0);
  syncer.setAutoSyncPeriod(Integer.parseInt(props.getProperty("AutoSync.Period","600")));

  for(int i=0;i<16;i++)
   {
   String defcol="",defvar="",defsnc="No",defomn="",defocm="";
   switch(i)
    {
    case 0:defomn="Open as NETBIOS server";defocm="explorer.exe \"\\\\%HOSTNAME%\"";defcol="Server comment";defvar="sdesc";defsnc="Yes";break;
    case 1:defomn="Open as FTP server";defocm="explorer.exe \"ftp://%HOSTIP%\"";defcol="Connection";defvar="ctime";defsnc="Yes";break;
    case 2:defcol="Custom comment";defvar="cdesc";defsnc="Yes";break;
    case 3:defcol="Last change";defvar="lchtm";defsnc="Yes";break;
    case 4:defvar="flags";defsnc="Yes";break;
    case 5:defvar="ison";defsnc="Yes";break;
    case 6:defvar="map";defsnc="Yes";break;
    case 7:defvar="!nbcache";defsnc="Yes";break;
    case 8:defvar="!ftpcache";defsnc="Yes";break;
    case 9:defvar="!httitle";defsnc="Yes";break;
    }
   colnames[i]=props.getProperty("ColNames.Column_"+Integer.toString(i),defcol);
   varnames[i]=props.getProperty("VarNames.Var_"+Integer.toString(i),defvar);
   syncable[i]=props.getProperty("Syncable.Par_"+Integer.toString(i),defsnc);
   opener.setOpenCmdMenu(i,props.getProperty("Open.Cmd.Menu_"+Integer.toString(i),defomn));
   opener.setOpenCmdCommand(i,props.getProperty("Open.Cmd.Command_"+Integer.toString(i),defocm));
   }
  opener.setNbResOpenCmd(props.getProperty("Open.NbResOpenCmd","explorer.exe \\\\%HOSTNAME%\\%RESNAME%"));
  opener.setFtpResOpenCmd(props.getProperty("Open.FtpResOpenCmd","explorer.exe ftp://%HOSTIP%/%RESNAME%"));
  opener.setHttpResOpenCmd(props.getProperty("Open.HttpResOpenCmd","explorer.exe http://%HOSTIP%/"));

  try
   {
   Rectangle bounds=new Rectangle(Integer.parseInt(props.getProperty("Window.X","0")),
                                  Integer.parseInt(props.getProperty("Window.Y","0")),
                                  Integer.parseInt(props.getProperty("Window.Width","500")),
                                  Integer.parseInt(props.getProperty("Window.Height","400")));
   setBounds(bounds);
   validate();
   }catch(NumberFormatException e)
   {
   this.setSize(500,400);
   }

  ApplySyncerSynList();
  }
  void SaveSetup()
  {
  FiltersSettings.SaveSetup();
  Properties props=new Properties();
  try
  {
  Runtime r=Runtime.getRuntime();
  FileInputStream s=new FileInputStream("jNV-client.set");
  props.load(s);
  s.close();
  }catch(IOException ex){;}

  try
  {
  Runtime r=Runtime.getRuntime();
  props.setProperty("Server.Host",syncer.getServerHost());
  props.setProperty("Server.Port",Integer.toString(syncer.getServerPort()));
  props.setProperty("Server.Login",syncer.getServerLogin());
  props.setProperty("Server.Password",syncer.getServerPassword());
  props.setProperty("AutoSync.Enabled",syncer.getAutoSyncEnabled()?"True":"False");
  props.setProperty("AutoSync.Period",Integer.toString(syncer.getAutoSyncPeriod()));
  for(int i=0;i<16;i++)
   {
   props.setProperty("ColNames.Column_"+Integer.toString(i),colnames[i]);
   props.setProperty("VarNames.Var_"+Integer.toString(i),varnames[i]);
   props.setProperty("Syncable.Par_"+Integer.toString(i),syncable[i]);
   props.setProperty("Open.Cmd.Menu_"+Integer.toString(i),opener.getOpenCmdMenu(i));
   props.setProperty("Open.Cmd.Command_"+Integer.toString(i),opener.getOpenCmdCommand(i));
   }
  props.setProperty("Open.NbResOpenCmd",opener.getNbResOpenCmd());
  props.setProperty("Open.FtpResOpenCmd",opener.getFtpResOpenCmd());
  props.setProperty("Open.HttpResOpenCmd",opener.getHttpResOpenCmd());


  Dimension scrsz=Toolkit.getDefaultToolkit().getScreenSize();
  Rectangle bounds=getBounds();

  if((getState()==Frame.NORMAL)&&(bounds.width<scrsz.width)&&(bounds.height<scrsz.height))
   {
   props.setProperty("Window.X",Integer.toString(bounds.x));
   props.setProperty("Window.Y",Integer.toString(bounds.y));
   props.setProperty("Window.Width",Integer.toString(bounds.width));
   props.setProperty("Window.Height",Integer.toString(bounds.height));
   }

  FileOutputStream s=new FileOutputStream("jNV-client.set");
  props.store(s,"jNetView by Killer{R}");
  s.close();
  }catch(IOException ex){;}
  }

  void jMenuItem6_actionPerformed(ActionEvent e) {
  NVAbout about=new NVAbout(this,"About jNetView client",true);
  about.show();
  }
  void jTable1_mousePressed(MouseEvent e) {

  }
  void jTable1_mouseReleased(MouseEvent e) {

  }
  void jTable1_mouseEntered(MouseEvent e) {

  }
  void jTable1_mouseExited(MouseEvent e) {

  }

  void RefreshViews(){
  IsRefreshing=true;
  RefreshTable();
  RefreshTree();
  sortmodel.sortByColumn(CurSortColumn,!CurSortInverse);
  IsRefreshing=false;
  System.gc();
  }

  MutableTreeNode SetShareNodes(MutableTreeNode root,String hn,String shares)
  {
  DefaultMutableTreeNode hnode=null;
  int index=0;
  Enumeration en=root.children();
  while(en.hasMoreElements())
   {
   DefaultMutableTreeNode n= (DefaultMutableTreeNode)en.nextElement();
   String s=(String)n.getUserObject();
   int cmp=s.compareToIgnoreCase(hn);
   if(cmp==0)
    {
    hnode=n;
    break;
    }else if(cmp>0)break;
   index++;
   }
  if(hnode==null)
   {
   hnode=new DefaultMutableTreeNode((Object)hn);
   treemodel.insertNodeInto(hnode,root,index);//root.insert(hnode,index);
   }
  while(hnode.getChildCount()>0)treemodel.removeNodeFromParent((MutableTreeNode)hnode.getChildAt(0));
  int j=0;
  for(int i=0;i<shares.length();i++)
  if(shares.charAt(i)=='\r')
   {
   String sn=shares.substring(j,i);
   j=i+1;
   if(FiltersSettings.canShowResource(sn))
    {
    MutableTreeNode n=new DefaultMutableTreeNode((Object)sn);
    treemodel.insertNodeInto(n,hnode,hnode.getChildCount());
    }
   }
  return hnode;
  }
  void RefreshTree(){
  MutableTreeNode root=(MutableTreeNode)jTree1.getModel().getRoot();
  if(root.getChildCount()==0)
   {
   treemodel.insertNodeInto(new DefaultMutableTreeNode((Object)"http://"),root,0);
   treemodel.insertNodeInto(new DefaultMutableTreeNode((Object)"ftp://"),root,0);
   treemodel.insertNodeInto(new DefaultMutableTreeNode((Object)"\\\\"),root,0);
   }

  jTree1.expandPath(new TreePath(root));

  MutableTreeNode nbroot=(MutableTreeNode)root.getChildAt(0);
  MutableTreeNode ftproot=(MutableTreeNode)root.getChildAt(1);
  MutableTreeNode httproot=(MutableTreeNode)root.getChildAt(2);
  Vector curnodes=new Vector(nbroot.getChildCount()+ftproot.getChildCount()+httproot.getChildCount());
  Enumeration en=nbroot.children();
  while(en.hasMoreElements())curnodes.addElement(en.nextElement());
  en=ftproot.children();
  while(en.hasMoreElements())curnodes.addElement(en.nextElement());
  en=httproot.children();
  while(en.hasMoreElements())curnodes.addElement(en.nextElement());


  for(int i=hostlist.size()-1;i>=0;i--)
   {
   NVHost h=hostlist.getHostAt(i);
   if(FiltersSettings.canShowHost(h))
    {
    String hn=h.getHostname()+" ["+h.getIp()+"]";
    String nbcache=h.getMetaVar("!nbcache");
    String ftpcache=h.getMetaVar("!ftpcache");
    String httitle=h.getMetaVar("!httitle");
    if(nbcache.length()!=0)
     {
     MutableTreeNode n=SetShareNodes(nbroot,hn,nbcache);
     if(curnodes.contains(n))curnodes.remove(n);
     }
    if(ftpcache.length()!=0)
     {
     MutableTreeNode n=SetShareNodes(ftproot,hn,ftpcache);
     if(curnodes.contains(n))curnodes.remove(n);
     }
    if(httitle.length()!=0)
     {
     httitle+="\r";
     MutableTreeNode n=SetShareNodes(httproot,hn,httitle.substring(1));
     if(curnodes.contains(n))curnodes.remove(n);
     }
    }
   }
  en=curnodes.elements();
  while(en.hasMoreElements())
   {
   DefaultMutableTreeNode n=(DefaultMutableTreeNode)en.nextElement();
   treemodel.removeNodeFromParent(n);
   }
  ExpandNodes(false);
  ExpandNodes(true);
  }

  void RefreshTable(){

  int k=3;
  for(int j=0;j<colnames.length;j++)
  if(colnames[j].length()!=0)k++;
  String curcols[]=new String[k];
  curcols[0]="Hostname";curcols[1]="IP address";curcols[2]="State";
  k=3;
  for(int j=0;j<colnames.length;j++)
  if(colnames[j].length()!=0)curcols[k++]=colnames[j];

  model.setColumnCount(k);
  model.setColumnIdentifiers(curcols);
  model.setRowCount(hostlist.size());


  int rowcnt=0;
  for(int i=hostlist.size()-1;i>=0;i--)
   {
   NVHost h=hostlist.getHostAt(i);
   if(FiltersSettings.canShowHost(h))
    {
    String ison=h.getMetaVar("ison");
    String flags=h.getMetaVar("flags");
    String state=(ison.length()!=0)?"["+ison.toUpperCase()+"]":"[?]";
    if(flags.length()!=0)
     {
     int iflags=Integer.parseInt(flags);
     if(((iflags&0x200)==0)&&((iflags&0x1400)!=0))state+=" {NB,FTP}";else
     if(((iflags&0x200)==0)&&((iflags&0x1400)==0))state+=" {NB}";else
     if(((iflags&0x200)!=0)&&((iflags&0x1400)!=0))state+=" {FTP}";
     }else state+=" {?}";
    sortmodel.setValueAt(h.getHostname(),rowcnt,0);
    sortmodel.setValueAt(h.getIp(),rowcnt,1);
    sortmodel.setValueAt(state,rowcnt,2);

    k=0;
    for(int j=0;j<varnames.length;j++)
    if(colnames[j].length()!=0)
     {
     sortmodel.setValueAt((varnames[j].length()!=0)?h.getMetaVar(varnames[j]):"",rowcnt,3+k);
     k++;
     }
    rowcnt++;
    }
   }
  model.setRowCount(rowcnt);
  sortmodel.reallocateIndexes();
  //setModel(model);
  }

  void jMenuItem9_actionPerformed(ActionEvent e) {
  JFileChooser fch=new JFileChooser();
  fch.setDialogTitle("Please choose full path to .NVH file to save");
  fch.setDialogType(JFileChooser.SAVE_DIALOG);
  if(fch.showSaveDialog(this)==JFileChooser.APPROVE_OPTION)
  {
  String fn=fch.getSelectedFile().getAbsolutePath();
  try{
  NVNvhProc.SaveHostList(hostlist,fn);
  }catch(IOException ex){
  JOptionPane.showMessageDialog(this,"Failed to save hostlist to file \""+fn+"\"");
  }
  }
  }

  void jMenuItem8_actionPerformed(ActionEvent e) {
  JFileChooser fch=new JFileChooser();
  fch.setDialogTitle("Please choose full path of .NVH file to load");
  fch.setDialogType(JFileChooser.OPEN_DIALOG);
  if(fch.showOpenDialog(this)==JFileChooser.APPROVE_OPTION)
  {
  String fn=fch.getSelectedFile().getAbsolutePath();
  try{
  NVNvhProc.LoadHostList(hostlist,fn);
  RefreshViews();
  }catch(IOException ex){
  JOptionPane.showMessageDialog(this,"Failed to load hostlist from file \""+fn+"\"");
  }
  }
  }

  void model_tableChanged(TableModelEvent e) {
  if((!IsRefreshing)&&(e.getType()==e.UPDATE)){
  int r=e.getFirstRow(),c=e.getColumn();
  String s=(String)sortmodel.getValueAt(r,c);
  NVHost h=(e.getColumn()!=0)?hostlist.getHostByName((String)sortmodel.getValueAt(r,0)):hostlist.getHostByIp((String)sortmodel.getValueAt(r,1));
  if(h!=null){
   if(c>2){
   String varname=varnames[c-3];
   h.setMetaVar(varname,s);
   }else if(c==1){
   h.setIp(s);
   IsRefreshing=true;
   sortmodel.setValueAt(h.getIp(),r,c);
   IsRefreshing=false;
   }else h.setHostname(s);
   }


  IsRefreshing=true;
  sortmodel.sortByColumn(CurSortColumn,!CurSortInverse);
  IsRefreshing=false;
  System.gc();
  }
  }
  void ExpandNodes(boolean state)
  {
  if(state)
   {
   for(int i=0;i<jTree1.getRowCount();i++)
   if(i<jTree1.getRowCount())jTree1.expandRow(i);
   }else
   {
   for(int i=jTree1.getRowCount()-1;i>=0;i--)
   if(i<jTree1.getRowCount())jTree1.collapseRow(i);
   }
  }
  void jMenuItem12_actionPerformed(ActionEvent e) {
  ExpandNodes(true);
  }

  void jMenuItem13_actionPerformed(ActionEvent e) {
  ExpandNodes(false);
  }

  void jMenuItem11_actionPerformed(ActionEvent e) {
  FiltersDialog dlg= new FiltersDialog(this,"Display filters",true);
  //dlg.setServerHost(syncer.getServerHost());
  dlg.setShowOffline(FiltersSettings.showoff);
  dlg.setEnableNetbios(FiltersSettings.shownb);
  dlg.setEnableFtp(FiltersSettings.showftp);
  dlg.setEnableHttp(FiltersSettings.showhttp);
  dlg.setEnableFltSubList(FiltersSettings.enfltsublist);
  dlg.setEnableFltResTree(FiltersSettings.enfltrestree);
  dlg.setShowHiddenRes(FiltersSettings.showhiddenres);
  dlg.setFltSubList(FiltersSettings.fltsublist);
  dlg.setFltResTree(FiltersSettings.fltrestree);
  dlg.show();
  }

  void UpdateFiltersFromDialog(FiltersDialog dlg) {
  FiltersSettings.showoff=dlg.getShowOffline();
  FiltersSettings.shownb=dlg.getEnableNetbios();
  FiltersSettings.showftp=dlg.getEnableFtp();
  FiltersSettings.showhttp=dlg.getEnableHttp();
  FiltersSettings.enfltsublist=dlg.getEnableFltSubList();
  FiltersSettings.enfltrestree=dlg.getEnableFltResTree();
  FiltersSettings.showhiddenres=dlg.getShowHiddenRes();
  FiltersSettings.fltsublist=dlg.getFltSubList();
  FiltersSettings.fltrestree=dlg.getFltResTree();
  FiltersSettings.SaveSetup();
  RefreshViews();
  }

  void OpenTreeSelectedResource(boolean ByDblClick){
  TreePath sp=jTree1.getSelectionPath();
  Object tn[]=sp.getPath();
  if(tn.length>2)
   {
   String hname=(String)((DefaultMutableTreeNode)tn[2]).getUserObject();
   int x=hname.indexOf(" ");
   if(x!=-1)hname=hname.substring(0,x);
   NVHost h=hostlist.getHostByName(hname);
   if((h!=null)&&((!ByDblClick)||(tn.length>3)))
    {
    String resname=(tn.length>3)?(String)((DefaultMutableTreeNode)tn[3]).getUserObject():"";
    int mode=0;
    switch(((DefaultMutableTreeNode)tn[0]).getIndex(((DefaultMutableTreeNode)tn[1])))
    {
      case 0:mode=0;break;
      case 1:mode=1;break;
      case 2:mode=2;break;
    }
    opener.OpenResource(h,resname,mode);
    }
   }
  }

  void jMenuItem7_actionPerformed(ActionEvent e) {
    OpenTreeSelectedResource(false);
  }


    public void addMouseListenerToHeaderInTable() {
        final TableSorter sorter = sortmodel;
        final JTable tableView = jTable1;
        tableView.setColumnSelectionAllowed(false);
        MouseAdapter listMouseListener = new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                TableColumnModel columnModel = tableView.getColumnModel();
                int viewColumn = columnModel.getColumnIndexAtX(e.getX());
                int column = tableView.convertColumnIndexToModel(viewColumn);
                if(e.getClickCount() == 1 && column != -1) {
                    if(column!=CurSortColumn){
                    CurSortColumn=column;
                    CurSortInverse=false;
                    }else CurSortInverse=!CurSortInverse;
                   sorter.sortByColumn(CurSortColumn, !CurSortInverse);
                }
             }
         };
        JTableHeader th = tableView.getTableHeader();
        th.addMouseListener(listMouseListener);
    }

}


