package jnv.hostlist;
import java.util.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class NVHost {
private static int DefHostNumber=0;
private Properties vars=new Properties();
private String ip;
private String hostname;
public NVHost() {
setHostname("host_"+Integer.toString(++DefHostNumber));
setIp("127.1."+Integer.toString((DefHostNumber>>8)&255)+"."+Integer.toString(DefHostNumber&255));
}
public NVHost(String hostname, String ip) {
setHostname(hostname);
setIp(ip);
}

public void setHostname(String hostname)
{
this.hostname=hostname.toLowerCase();
}
public void setIp(String ip)
{
if(ValidateIp(ip))this.ip=ip;
}
public String getHostname()
{
return hostname;
}
public String getIp()
{
return ip;
}
public Enumeration getVarNames()
{
return vars.propertyNames();
}

private boolean ValidateIp(String ip)
{
int j=0,k=0;
ip+=".";
for(int i=0;i<ip.length();i++)
if(ip.charAt(i)=='.')
 {
 if(++k>4)return false;
 try
  {
  int vip=Integer.parseInt(ip.substring(j,i));
  if((vip<0)||(vip>255))return false;
  }catch(NumberFormatException e)
  {
  return false;
  }
 j=i+1;
 }
return true;
}


public String getMetaVar(String varname){
return vars.getProperty(varname,"");
}
public String[] getMetaVars(String[] varnames){
String ret[]=new String[varnames.length];
for(int i=0;i<varnames.length;i++)ret[i]=getMetaVar(varnames[i]);
return ret;
}

public void setMetaVar(String varname, String vardata){
vars.setProperty(varname,vardata);
}
public void setMetaVars(String varnames[], String vardata[]){
for(int i=0;i<varnames.length;i++)vars.setProperty(varnames[i],vardata[i]);
}

}