package jnv.netproc;

import jnv.hostlist.*;
import java.util.Collection;
import java.util.Iterator;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2005</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class NVOpener {
  private NVHostList hostlist;
  private String OpenCmdMenu[]=new String[16];
  private String OpenCmdCommand[]=new String[16];
  private String NbResOpenCmd=new String();
  private String FtpResOpenCmd=new String();
  private String HttpResOpenCmd=new String();
  public NVOpener(NVHostList hostlist) {
  this.hostlist=hostlist;
  }

  private String ExchangeWildCards(String s,String wc,String xs)
  {
  String ret=s;
  int x=ret.indexOf(wc);
  while(x!=-1)
   {
   ret=ret.substring(0,x)+xs+ret.substring(x+wc.length(),ret.length());
   x=ret.indexOf(wc);
   }
  return ret;
  }

  public void OpenResource(NVHost h, String resname, int Mode){//Mode= 0-nb, 1-ftp, 2-http
  String Path="";
  switch(Mode)
  {
    case 0:Path = NbResOpenCmd;break;
    case 1:Path = FtpResOpenCmd;break;
    case 2:Path = HttpResOpenCmd;break;
  }
  Path=ExchangeWildCards(Path,"%HOSTNAME%",h.getHostname());
  Path=ExchangeWildCards(Path,"%HOSTIP%",h.getIp());
  Path=ExchangeWildCards(Path,"%RESNAME%",resname);
  OpenPath(Path);
  }

  public void OpenHost(NVHost h, int Mode)
  {
  String Path=ExchangeWildCards(OpenCmdCommand[Mode],"%HOSTNAME%",h.getHostname());
  Path=ExchangeWildCards(Path,"%HOSTIP%",h.getIp());
  OpenPath(Path);
  }
  public void OpenPath(String Path)
  {
    try
    {
    Runtime.getRuntime().exec(Path);
    }catch (Exception e){ e.printStackTrace(); }
  }
 public String getOpenCmdMenu(int i){
 return OpenCmdMenu[i];
 }
 public String getOpenCmdCommand(int i){
 return OpenCmdCommand[i];
 }
 public void setOpenCmdMenu(int i, String val){
 OpenCmdMenu[i]=val;
 }
 public void setOpenCmdCommand(int i, String val){
 OpenCmdCommand[i]=val;
 }

 public void setNbResOpenCmd(String val){
 NbResOpenCmd=val;
 }
 public void setFtpResOpenCmd(String val){
 FtpResOpenCmd=val;
 }
 public void setHttpResOpenCmd(String val){
 HttpResOpenCmd=val;
 }

 public String getNbResOpenCmd(){
 return NbResOpenCmd;
 }
 public String getFtpResOpenCmd(){
 return FtpResOpenCmd;
 }
 public String getHttpResOpenCmd(){
 return HttpResOpenCmd;
 }

}